import time
import traceback
import sys
import atexit

def _log(txt):
    f = open("/tmp/whatthefuckisgoingon.log", "a")
    f.write("%s: %s\n" % (time.strftime("%Y-%m-%d %H:%M:%S"), txt))
    f.close()

def _format_tb(tb):
    lines = traceback.format_tb(tb)
    indented = [("    " + x) for x in lines]
    return "".join(indented)

def f_problems(e_type, e_value, e_traceback):
    sys.settrace(None)
    _log("Problems! type: " + str(e_type))
    _log("Problems! value: " + str(e_value))
    _log("Problems! traceback:\n" + _format_tb(e_traceback))

def f_exit():
    _log("Exiting...")

def f_trace(frame, event, arg):
    frame_details = "(# %s @ %s)" % (frame.f_lineno, frame.f_code.co_filename)
    _log("Tracing: %s (%s) %s" % (event, arg, frame_details))
    return f_trace

atexit.register(f_exit)
sys.excepthook = f_problems
sys.settrace(f_trace)
